/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        11.01.2009
 Description:    Power Supply LED Display

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
----------------------------------------------------------------------------*/

#include <avr/interrupt.h>
#include <avr/io.h>
#include "timer.h"

//---------------------------------------------------------------------------
//ADC Interrupt
ISR (ADC_vect)
{
    ADCSRA = 0;
    if ((ADMUX&0x0F) == 1)
    {
		//ADC (SPANNUNG)
		for (unsigned char a = (BUFFER_SIZE - 1);a > 0;a--)
		{
			display_value_1[a] = display_value_1[a-1];
		}
        display_value_1[0] = (ADC/1.024)/2;
        ADMUX = 0;
    }
    else
    {
		//ADC (STROM)
		for (unsigned char a = (BUFFER_SIZE - 1);a > 0;a--)
		{
			display_value_2[a] = display_value_2[a-1];
		}
        display_value_2[0] = (ADC/1.024)/4;
		
		if(display_value_2[0] < 6) display_value_2[0] = 0; 
		
        ADMUX = (1<<MUX0);
    }
    ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
}



int main (void) 
{
  DDRD |= (1<<PD0)|(1<<PD1)|(1<<PD2)|(1<<PD3)|(1<<PD4)|(1<<PD5)|(1<<PD6);
  DDRB |= (1<<PB0)|(1<<PB1)|(1<<PB2)|(1<<PB3)|(1<<PB4)|(1<<PB5);
  
  sei();
	
  //ADC initialisieren
  ADMUX = (1<<MUX0);
  //Free Running Mode, Division Factor 128, Interrupt on
  ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
  
  init_timer3();
  
  while(1)
  {
	update = 1;
	for (unsigned long a = 0;a<70000;a++) {asm("nop");};
  }
}

